/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define sub level procedure to debug	*/
/*	memory problem				*/
/*						*/
/************************************************/
#ifndef DBGMEM
#define DBGMEM

/*define it at compile if you want to look for 	*/
/*memory leak, report is displayed each time	*/
/*dbg_dumpmem is called.			*/
#ifdef	DEBUG
/*
#define DEBUGMEM
*/
#endif

/*to activate Memory leak detector		*/
#define	DMTRUE	1	/*Boolean		*/
#define	DMFALSE	0	/*Boolean		*/

#ifdef DEBUGMEM
#ifndef DEBUG
#error "Caution, See dbgmem.h,"
#error "you should use DEBUGMEM in DEBUG compilation mode"
#endif
#define DMTRACE	DMTRUE	
#else
#define DMTRACE	DMFALSE	
#endif

#ifdef	DEBUGMEM	
#define	calloc	dbg_calloc
#define	malloc	dbg_malloc
#define	realloc	dbg_realloc
#define	free	dbg_free

#undef strdup
#define	strdup	dbg_strdup
#endif

extern int memleak;

extern void dbg_setcurpath(char *path);
extern void *dbg_malloc(size_t size);
extern void *dbg_calloc(size_t nmemb,size_t size);
extern void dbg_free(void *ptr);
extern void *dbg_realloc(void *ptr,size_t size);
extern char *dbg_strdup(const char *str);
extern void dbg_dumpmem(const char *appname);
extern void dbg_sysfree(void *ptr);
#endif
