/************************************************/
/*						*/
/*      Copyright:				*/
/*		 Jean-Marc Pigeon <jmp@safe.ca>	*/
/*	Distributed under the Gnu Public	*/
/*	License, see the License file in this	*/
/*	package.				*/
/*						*/
/*	Define procedure to manage child process*/
/*	number.					*/
/*						*/
/************************************************/
#ifndef LVLCHL
#define LVLCHL
#include	"unidev.h"
#include	"gesque.h"
#include	"gesipc.h"
#include	"gescnf.h"

typedef	enum	{	/*aux process child type	*/
	chl_sender,	/*sending process		*/
	chl_checker,	/*checker process		*/
	chl_transponder,/*transponder process		*/
	chl_unknown	/*unknown child type process	*/
	}ECHTYP;

#define	NSRV	((int)chl_unknown)

typedef	struct	{
	BOXTYP *boxe;	/*IPC boxe exchange		*/
	char *smtpsrv;	/*local smtp sender		*/
	char *spmdsrv;	/*SPAM detector daemon		*/
	char *rmponder;	/*Mentor local trpdr interface	*/
	int newchild;	/*new child started		*/
	pid_t pid[NSRV];/*server pids			*/
	char *chkidsrv;	/*User check-id Server		*/
	char *chkidmod;	/*check-id check mode		*/
	char **frelais;	/*relay list filename		*/
	time_t lastload;/*last mng load			*/
	IPTYP **relais;	/*accepted relay list		*/
	LSTTYP **look;	/*binded channel		*/
	AUXTYP **auxs;	/*auxiliary list		*/
	}CHLTYP;

extern const char *alrt[];
extern void chl_dropchldinfo();
extern void chl_dumpchldinfo(CHLTYP *mng);
extern pid_t chl_getchlpid(ECHTYP aux);
#endif
